﻿using System;
using System.Xml;

namespace PdpRtuDownloader.Database.Gateways
{
    public class RtuConfigGw: DbGateway<DomainObjects.RtuConfig>
    {
        public RtuConfigGw()
        {
        }

        public override string GetRootElementName()
        {
            return "rtu_configs";
        }

        public override string GetElementName()
        {
            return "rtu_config";
        }

        public override bool PkEquals(DomainObjects.RtuConfig domainObjectA, DomainObjects.RtuConfig domainObjectB)
        {
            if (domainObjectA != null && domainObjectB != null)
            {
                return domainObjectA.StationId == domainObjectB.StationId;
            }
            else
            {
                return false;
            }
        }

        public override void LoadFromXml(DomainObjects.RtuConfig domainObject, XmlNode node)
        {
            domainObject.StationId = Convert.ToInt32(node.Attributes["station_id"].Value);
            domainObject.Name = node.Attributes["name"].Value;
            domainObject.Uri = node.Attributes["uri"].Value;
            domainObject.Login = node.Attributes["login"].Value;
            domainObject.Password = node.Attributes["password"].Value;
            domainObject.Description = node.Attributes["description"].Value;
            domainObject.FourPhases = Convert.ToBoolean(node.Attributes["four_phases"].Value);
            domainObject.Locked = Convert.ToBoolean(node.Attributes["locked"].Value);
            domainObject.Active = Convert.ToBoolean(node.Attributes["active"].Value);
        }

        public override void SaveToXml(DomainObjects.RtuConfig domainObject, XmlNode node)
        {
            XmlDocument doc = node.OwnerDocument;

            node.Attributes.Append(doc.CreateAttribute("station_id")).Value = Convert.ToString(domainObject.StationId);
            node.Attributes.Append(doc.CreateAttribute("name")).Value = domainObject.Name;
            node.Attributes.Append(doc.CreateAttribute("uri")).Value = domainObject.Uri;
            node.Attributes.Append(doc.CreateAttribute("login")).Value = domainObject.Login;
            node.Attributes.Append(doc.CreateAttribute("password")).Value = domainObject.Password;
            node.Attributes.Append(doc.CreateAttribute("description")).Value = domainObject.Description;
            node.Attributes.Append(doc.CreateAttribute("four_phases")).Value = Convert.ToString(domainObject.FourPhases);
            node.Attributes.Append(doc.CreateAttribute("locked")).Value = Convert.ToString(domainObject.Locked);
            node.Attributes.Append(doc.CreateAttribute("active")).Value = Convert.ToString(domainObject.Active);
        }
    }
}

