﻿using System;

namespace PdpRtuDownloader.Measurement
{
    /// <summary>
    /// Represents single measurement data (phase signals, metadata and peak classification).
    /// </summary>
    public class MeasurementData
    {
        #region Members

        private string timestamp;
        private MeasurementMetadata metadata;
        private PeakClassification peakClassification;

        private byte[] ch1Data;
        private byte[] ch2Data;
        private byte[] ch3Data;
        private byte[] ch4Data;
        private bool fourPhases;
        private int samplingRate;

        #endregion

        #region Properties

        public string Timestamp
        {
            get { return timestamp; }
            set { timestamp = value; } 
        }

        public MeasurementMetadata Metadata
        {
            get { return metadata; }
            set { metadata = value; }
        }

        public PeakClassification PeakClassification
        {
            get { return peakClassification; }
            set { peakClassification = value; }
        }

        public byte[] Ch1Data
        {
            get { return ch1Data; }
            set { ch1Data = value; }
        }

        public byte[] Ch2Data
        {
            get { return ch2Data; }
            set { ch2Data = value; }
        }

        public byte[] Ch3Data
        {
            get { return ch3Data; }
            set { ch3Data = value; }
        }

        public byte[] Ch4Data
        {
            get { return ch4Data; }
            set { ch4Data = value; }
        }

        public bool FourPhases
        {
            get { return fourPhases; }
            set { fourPhases = value; }
        }

        public int SamplingRate
        {
            get { return samplingRate; }
            set { samplingRate = value; }
        }

        #endregion

        #region Methods

        public override string ToString()
        {
            return string.Format("[MeasurementData: Timestamp={0}, Metadata={1}, PeakClassification={2}, Ch1Data={3}, Ch2Data={4}, Ch3Data={5}, Ch4Data={6}, FourPhases={7}, SamplingRate={8}]",
                Timestamp, Metadata, PeakClassification, Ch1Data, Ch2Data, Ch3Data, Ch4Data, FourPhases, SamplingRate);
        }

        #endregion
    }
}

